<?php

namespace Drupal\feeds_plupload\Feeds\Fetcher\Form;

use Drupal\Component\Serialization\Json;
use Drupal\Core\Form\FormStateInterface;
use Drupal\feeds\FeedInterface;
use Drupal\feeds\Plugin\Type\ExternalPluginFormBase;

/**
 * Provides a form on the feed edit page for the plupload fetcher.
 */
class PluploadFetcherFeedForm extends ExternalPluginFormBase {

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(
    array $form,
    FormStateInterface $form_state,
    FeedInterface $feed = NULL
  ) {
    $form['source'] = [
      '#type' => 'plupload',
      '#title' => t('Upload files'),
      '#required' => TRUE,
      '#autoupload' => $this->plugin->getConfiguration('autoupload'),
      '#autosubmit' => $this->plugin->getConfiguration('autosumbit'),
      '#upload_validators' => [
        'file_validate_extensions' => [
          $this->plugin->getConfiguration('allowed_extensions'),
        ],
      ],
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(
    array &$form,
    FormStateInterface $form_state,
    FeedInterface $feed = NULL
  ) {
    $feed->setSource(Json::encode($form_state->getValue('source')));
  }

}
